﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace WpfApp2
{
    public class MainWindowViewModel : INotifyPropertyChanged
    {
        private Person _filledPerson;
        public ObservableCollection<Person> Persons { get; set;}
        public ICommand AddPerson { get; set; }

        public Person FilledPerson
        {
            get { return _filledPerson; }
            set
            {
                if (_filledPerson != value)
                {
                    _filledPerson = value;
                    RaisePropertyChanged("FilledPerson");
                }
            }
        }

        public MainWindowViewModel() {
            _filledPerson = new Person(0, "", false);
            InitPersons();
            AddPerson = new AddPersonCommand(this);
        }

        public event PropertyChangedEventHandler? PropertyChanged;

        private void InitPersons()
        {
            Persons = new ObservableCollection<Person>();
            Persons.Add(new Person(1, "John Doe", false));
            Persons.Add(new Person(42, "Jane Smith", true));

        }

        private void RaisePropertyChanged(string propertyName) {
            if (propertyName != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
