﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Security.Policy;
using System.Text;
using System.Threading.Tasks;

namespace WpfApp2
{
    public class Person : INotifyPropertyChanged
    {
        private int _id;
        private string _name;
        private bool _isStudent;

        public int Id
        {
            get { return _id; }
            set
            {
                if (_id != value)
                {
                      _id = value;
                    RaisePropertyChanged("Id");
                }
            }
        }

        public string Name
        {
            get
            {
                return _name;
            }
            set {
                if (_name != value)
                {
                    _name = value;
                    RaisePropertyChanged("Name");
                }
            }
        }

        public bool IsStudent
        {
            get
            {
                return _isStudent;
            }
            set
            {
                if (_isStudent != value)
                {
                    _isStudent = value;
                    RaisePropertyChanged("IsStudent");
                }
            }
        }

        public Person(int id, string name, bool isStudent)
        {
            _id = id;
            _name = name;
            _isStudent = isStudent;
        }

        public event PropertyChangedEventHandler? PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            if (propertyName != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        
    }
}
